# $Id: entropy.R 116 2008-04-01 01:29:45Z srevilak $

# Routines for computing entropy

mylog2 <- function(x) {
  rv <- 0
  if (x != 0) {
    rv <- log2(x);
  }
  rv
}


entropy <- function(x) {
  # user convenience - turn x into a probability distribution
  sum_x <- sum(x);
  values <- sapply(x, function(v) { v/sum_x});

  sum_over <- sapply(values, function(v) { v * mylog2(v)});
  rv <- (-1 * sum(sum_over));
  rv
}
